searchNodes=[{"ref":"Herald.html","title":"Herald","type":"module","doc":""},{"ref":"Herald.Errors.InvalidRoute.html","title":"Herald.Errors.InvalidRoute","type":"exception","doc":""},{"ref":"Herald.Errors.InvalidRouteProcessor.html","title":"Herald.Errors.InvalidRouteProcessor","type":"exception","doc":""},{"ref":"Herald.Errors.MissingRouter.html","title":"Herald.Errors.MissingRouter","type":"exception","doc":""},{"ref":"Herald.Message.html","title":"Herald.Message","type":"module","doc":"Defines the behaviour to Message Schemas. Message Schemas are the structs which represents data exchanged using a Broker queue. Any message which you expect receive or send in your application must be represented by a module, and this module must use/2Herald.Message and defines a payload/1 for the represented message, as bellow: defmodule MyApp.UserRegistered do use Herald.Message payload do field :age, :integer field :name, :string, required: true end end Each message received in the broker is converted in a struct with the following fields: id - A unique UUID for message. Can be used to filter duplicated messages; queue - The queue where this message is received of will be sent; payload - Content of message, represented by a map of atom keys, and defined by payload/3 call in module definition; valid? - Indicates if message is valid, eg, with all fields have correct type, and if required fields are present. The definition of which Message Schema will be used to represents a message received from broker must be created in Router. More details, see Herald.Router."},{"ref":"Herald.Message.html#field/3","title":"Herald.Message.field/3","type":"macro","doc":"Defines a field of payload. Fields receives a name, type, and can have aditional options. Options required - A boolean indicating if field is required to be present or not."},{"ref":"Herald.Message.html#payload/1","title":"Herald.Message.payload/1","type":"macro","doc":"Defines the valid payload for a message, i.e. wrap all field/3 calls"},{"ref":"Herald.Pipeline.html","title":"Herald.Pipeline","type":"module","doc":"Pipeline is where messages are processed. All message processing is started by function run/2. When run/2 receives a message, it runs the following steps: pre_processing - Will convert the message to a struct, using the schema defined in route for the given queue; processor_caler - Will call the processor defined in router for the given queue."},{"ref":"Herald.Pipeline.html#run/2","title":"Herald.Pipeline.run/2","type":"function","doc":"Process a given message. Receive the following arguments: queue - The queue where message was received from; message - The received message in a raw state (i.e. the String as received from broker) This function must be called by plugins integrating Herald with Brokers. Warning: When you call this function without configure a router for you application, it will raises the exception Herald.Errors.MissingRouter"},{"ref":"Herald.Pipeline.html#t:t/0","title":"Herald.Pipeline.t/0","type":"type","doc":""},{"ref":"Herald.Pipeline.html#t:to_perform/0","title":"Herald.Pipeline.to_perform/0","type":"type","doc":"Indicates to upper layers what must do doing with message. Possible values: :ack - When the message is sucessfully processed; :delete - When message must be deleted from broker after a processing error; :requeue - When message must be reprocessed in future after a processing error."},{"ref":"Herald.Router.html","title":"Herald.Router","type":"module","doc":"Provides the routes DSL. Routes is a way trought Herald know: Which Message Schema uses to encode a message before send it; Which function must be used to process a message when receives An router must be implemented as a module of your application, as bellow: defmodule MyApp.Router do use Herald.Router route &quot;my_queue1&quot;, schema: MyApp.Message1, processor: &amp;MyApp.Message1.my_processor/1 route &quot;my_queue2&quot;, schema: MyApp.Message2, processor: &amp;MyApp.Message2.my_processor/1 end Each application using Herald must have only one router. You need to inform Herald where is your Router using application configurations, as bellow: config :herald, router: MyApp.Router For more details, see route/2"},{"ref":"Herald.Router.html#route/2","title":"Herald.Router.route/2","type":"macro","doc":"Defines a config for a given queue. Config fields schema - Represents a struct using Herald.Message which will be used to represent any message received in queue; processor - Represents a function which will process messages received in queue. For more details, see the module doc."},{"ref":"1-quick-start.html","title":"Quick start","type":"extras","doc":"Quick start Message exchange is a widely used pattern in technology world, mainly in microservices ecosystems. Herald aims to be a tool which allow companies implement this pattern in a simple way, releasing the developers to think in business logic instead details about broker communication, message exchange, etc. To getting started with Herald, execute the following steps:"},{"ref":"1-quick-start.html#install-it","title":"Quick start - Install it","type":"extras","doc":"Add in your mix.exs and run mix deps.get: def deps do [ {:herald, &quot;~&gt; 0.1.0&quot;} ] end"},{"ref":"1-quick-start.html#install-broker-plugin","title":"Quick start - Install broker plugin","type":"extras","doc":"Install one of the following libraries: Herald AMQP Herald SQS"},{"ref":"1-quick-start.html#create-a-message-schema","title":"Quick start - Create a Message Schema:","type":"extras","doc":"In Message Schema you&#39;ll defines what is the expected fields for some messages: defmodule MyApp.UserMessage do use Herald.Message payload do field :id, :integer, required: true field :age, :integer, required: true field :name, :string, required: true end end"},{"ref":"1-quick-start.html#create-processor-function","title":"Quick start - Create processor function","type":"extras","doc":"Processor function will work as a callback function when a message is received. In our case, we created the message in the same module of MyApp.UserMessage, but your can create where your business logic requires: defmodule MyApp.UserMessage do use Herald.Message payload do field :id, :integer, required: true field :age, :integer, required: true field :name, :string, required: true end def my_processor(%MyApp.UserMessage{} = message) do if do_some_stuff_with(message) do {:ok, message} else {:error, :my_bad_error} end end end Processor return The processor function return must match with one of the following expressions: {:ok, _} - When desired operation is processed with success. Message will be acknowledged in broker, if needed; {:error, _} - When processor don&#39;t reached the desired result. Message will be rejected in broker; {:error. :delete, _} - The same of {:error, _}, but message will be deleted from broker, if needed."},{"ref":"1-quick-start.html#create-router","title":"Quick start - Create Router","type":"extras","doc":"Router will tell for Herald what Message Schema and processor use for process each message received. In example bellow, any message received in queue user:created will be validated by schema MyApp.UserMessage and processed by function &amp;MyApp.UserMessage.func/1: defmodule MyApp.Router do use Herald.Router route &quot;user:created&quot;, schema: MyApp.UserMessage, processor: &amp;MyApp.UserMessage.func/1 end"},{"ref":"1-quick-start.html#configure-app","title":"Quick start - Configure app","type":"extras","doc":"Finaly, need inform Herald what is the module where Router is configured: config :herald, router: MyApp.Router"},{"ref":"2-concepts.html","title":"Concepts","type":"extras","doc":"Concepts This section aims to introduce you the main concepts you need to know to understand Herald."},{"ref":"2-concepts.html#message-schema","title":"Concepts - Message Schema","type":"extras","doc":"Not rarely, with the growth or systems evolutions, problems comes too! A lot of companies have a lot of problems with inconsistent messages between systems, mainly because the message payload was changed in some systems without necessarily having been updated in the other. Herald prevent this introducing a concept of Message Schema, i.e., a strong payload definition for message, which will be used to validate and represent a message. Bellow, you can see a example of Message Schema implementation: defmodule MyApp.UserMessage do use Herald.Message payload do field :id, :integer, required: true field :age, :integer, required: true field :name, :string, required: true end end Using Herald.Message.field/3 you can define all fields which should be present in your message, as well your types. Case any field must be present, you must set option required as true, as shown above. Note that you message have any field which was not declared in your payload, this field will be discarted. Note: Internally, Message Schemas are validated using Ecto, allowing extensibility of these validations in the future. See Herald.Message for more details."},{"ref":"2-concepts.html#message-routes","title":"Concepts - Message Routes","type":"extras","doc":"Routes let Herald to known what Message Schema] use to decode messages received in the given queue, and what is the function which must be called to process these message. See the example bellow: defmodule MyApp.Router do use Herald.Router route &quot;user:created&quot;, schema: MyApp.UserMessage, processor: &amp;MyApp.func/1 end This router tells the following to Herald: Always a message is received in the queue user:created, Herald must use the payload defined in module MyApp.UserMessage to validate and represent this message; After this message is parsed and converted into a struct of MyApp.UserMessage, the function MyApp.func/1 will be called passing this struct for these function; See Herald.Router for more details."},{"ref":"2-concepts.html#message-pipeline","title":"Concepts - Message Pipeline","type":"extras","doc":"The message pipeline is the central component of Herald, exposed by the function Herald.Pipeline.run/2, and called by Herald AMQP and Herald SQS to process messages. Basically, this function will receive a raw message and the queue where it originated, and will: Get the route details for the given queue; Decode the message using message schema; Once message is decoded, send it to their processor; Returns to the caller function If you want to develop a plugin to integrate Herald with a message broker, the function Herald.Pipeline.run/2 will be the point of integration of your plugin with Herald Core. See Herald.Pipeline for more details."}]